//+-------------------------------------------------------------------------------------+
//|                                                                     MorningFlat.mq4 |
//|                                                                           Scriptong |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "http://autograf.dp.ua"

#property indicator_chart_window

extern string A1 = " :  ";
extern int    StartHour = 22;
extern int    StartMinute = 0;
extern string A2 = " :  ";
extern int    EndHour = 7;
extern int    EndMinute = 0;
extern string A3 = "        ";
extern double TargetLevel = 161.8;
extern double TargetLevel2 = 261.8;
extern string A4 = "       ";
extern int    Offset = 10;  
extern string A5 = "    ";
extern color  UpChannelColor = Turquoise;
extern color  DownChannelColor = Red;
extern color  TargetUp1Color = Gold;
extern color  TargetDn1Color = Silver;
extern color  TargetUp2Color = DarkViolet;
extern color  TargetDn2Color = CornflowerBlue;

double Off;
bool Activate;
datetime LastDay;
string prefix = "MOFL_";
int BarMax,                                        //   ..
                                                   // ..,   ..
                                                   // ..  
    StartTime,                                     //     
                                                   // ..
    EndTime;                                       //     
                                                   // ..
//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
{
   Activate = false;
// - 1 - ==     ==================================
   if(Period() > PERIOD_H1) 
   {
      Alert("     H4!");
      return(0);   
   }
   if (StartHour < 0 || EndHour < 0 || StartHour > 23 || EndHour > 23)
   {
      Alert(" StartHour  EndHour      0  24");
      return(0);
   } 
    
   if(StartMinute < 0 || EndMinute < 0 || StartMinute > 59 || EndMinute > 59)
     {
      Comment(" StartHour  EndHour      0  24  ",
              "StartHour < EndHour.");
      return(0);
     } 
     
   if (TargetLevel < 100 || TargetLevel2 < 100)
     {
      Comment("  TargetLevel  TargetLevel2    100.");
      return(0);
     }  
// - 1 - ==   =============================================================
    
// - 2 - ==    ==================================================
   int cnt = 0;
   while (cnt < 10000)
   {
      int M1Bars = iBars(NULL, PERIOD_M1);         //    1
      if (GetLastError() != 4066)
         break;
      cnt++;
   }      
   if (M1Bars < 7200)                              //   1  
   {                                               // ..   ,  
      Alert("      !");
      Alert("  M1 - http://autograf.dp.ua/Pages/7/72/725/725.htm");
      return(0);
   }
   BarMax = iBarShift(NULL, 0, Time[M1Bars]);      //   
// - 2 - ==    ===============================================
    
     
// - 3 - ==    ===============================================
   Off = Offset*Point;  
   StartTime = StartHour*60 + StartMinute;         //  :  ..
   EndTime = EndHour*60 + EndMinute;               // ..
// - 3 - ==   =============================================================

   LastDay = 0;
   Activate = True;

   return(0);
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                          |
//+-------------------------------------------------------------------------------------+
int deinit()
{
   //   - 
   for (int i = ObjectsTotal()-1; i >= 0; i--)
      if (StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)
        ObjectDelete(ObjectName(i));
   return(0);
}

//+-------------------------------------------------------------------------------------+
//|                                                        |
//+-------------------------------------------------------------------------------------+
void DrawLabel(datetime time, double price, color _color)
{
   string name = prefix + time + _color + "_label";

   if (ObjectCreate(name, OBJ_ARROW, 0, time, price))
   {
      ObjectSet(name, OBJPROP_ARROWCODE, 5);
      ObjectSet(name, OBJPROP_COLOR, _color);
   } 
}
//+-------------------------------------------------------------------------------------+
//|                                  |
//+-------------------------------------------------------------------------------------+
void DrawLine(datetime time1, double price, datetime time2, color _color)
{
   string name = prefix + time1 + _color;

   if (ObjectFind(name) < 0)
   {
      ObjectCreate(name, OBJ_TREND, 0, time1, price, time2, price);
      ObjectSet(name, OBJPROP_COLOR, _color);
      ObjectSet(name, OBJPROP_RAY, false);
   }
   else
   {
      ObjectMove(name, 0, time1, price);
      ObjectMove(name, 1, time2, price);
   }
}  
//+-------------------------------------------------------------------------------------+
//|                                        |
//+-------------------------------------------------------------------------------------+
int GetBarIndex(datetime time, int tf)
{
   int cnt = 0;                                    //   
   while (cnt < 10000)                             //    10 000 
   {
      int res = iBarShift(NULL, tf, time);         //   
      if (GetLastError() != 4066)                  //      ,
         return(res);                              // ..  
      cnt++;
   }
   return(-1);                                     //  
}
//+-------------------------------------------------------------------------------------+
//|                                           |
//+-------------------------------------------------------------------------------------+
int GetTimeOfBarIndex(int index, int tf)
{
   int cnt = 0;                                    //   
   while (cnt < 10000)                             //    10 000 
   {
      int res = iTime(NULL, tf, index);            //    
      if (GetLastError() != 4066)                  //      ,
         return(res);                              // ..  
      cnt++;
   }
   return(-1);                                     //  
}
//+-------------------------------------------------------------------------------------+
//|    .                                                          |
//+-------------------------------------------------------------------------------------+
datetime DecDay(datetime time, int amount)
{
   int day_num = GetBarIndex(time, PERIOD_D1);     //   
   if (day_num < 0)                                //   ,  ..
      return(-1);                                  // ..
   datetime res = GetTimeOfBarIndex(day_num-amount,//    
                                    PERIOD_D1);
   if (res < 0)                                    //   ,  ..
      return(-1);                                  // ..
   return(res);                                    //    ,  ..
                                                   // ..
}
//+-------------------------------------------------------------------------------------+
//|      .   time        |
//|  ,   1.    - 0.  - -1.             |
//+-------------------------------------------------------------------------------------+
int IsTimeOutOfFlat(datetime time, datetime &start, datetime &end, datetime &next)
{
// - 1 - ==        =============
   int curtime = TimeHour(time)*60 + TimeMinute(time);//     
   datetime curday = time - curtime*60;            //   
   if (LastDay >= curday)                          //   time  , ..
      return(0);                                   // .. 0
// - 1 - ==   =============================================================

// - 2 - ==     ============================================
   if (StartTime > EndTime)                        //    ..
   {                                               // ..,   ..
                                                   // ..   
      if (curtime >= StartTime || curtime > EndTime)//      ..
         return(0);                                // ..   ..
                                                   // ..   ..
                                                   // ..
      datetime prevday = DecDay(curday, -1);       //    
      if (prevday < 0)                             //   , ..
         return(-1);                               // .. 
      start = prevday + StartTime*60;              //   
      end = curday + EndTime*60;                   //   
      next = curday + 86400;                       //    
      return(1);                                   //   
   }                                      
// - 2 - ==   =============================================================

// - 3 - ==     ============================================
   else                                            //     -
   {                                               // ..   ..
                                                   // ..
      if (curtime >= StartTime && curtime <= EndTime)//     ..
         return(0);                                // ..    ..
                                                   // ..   
      start = curday + StartTime*60;               //   
      end = curday + EndTime*60;                   //   
      next = curday + 86400;                       //    
      return(1);                                   //    
   }
// - 3 - ==   =============================================================
}
//+-------------------------------------------------------------------------------------+
//|                                                    |
//+-------------------------------------------------------------------------------------+
bool ShowLevels(datetime start, datetime end, datetime next)
{
// - 1 - ==    ====================================================
   int start_bar = GetBarIndex(start, PERIOD_M1);  //     ..
                                                   // ..
   if (start_bar < 0)                              //    
      return(false); 
   int end_bar = GetBarIndex(end, PERIOD_M1);      //     ..
                                                   // ..
   if (end_bar < 0)                                //    
      return(false); 
   double low = iLow(NULL, PERIOD_M1,              //     ..
                     iLowest(NULL, PERIOD_M1,      // .. Offset
                             MODE_LOW, start_bar-end_bar, end_bar+1)) - Off;
   double high = iHigh(NULL, PERIOD_M1,            //     ..
                       iHighest(NULL, PERIOD_M1,   // .. Offset
                                MODE_HIGH, start_bar-end_bar, end_bar+1)) + Off;
   double targetU = high+(high-low)*(TargetLevel-100)/100;  //   1
   double targetD = low-(high-low)*(TargetLevel-100)/100;   //   1
   double targetU2 = high+(high-low)*(TargetLevel2-100)/100;//   2
   double targetD2 = low-(high-low)*(TargetLevel2-100)/100; //   2
// - 1 - ==   =============================================================

// - 2 - ==      ============================================
   DrawLine(start, high, end, UpChannelColor);     //    
   DrawLine(start, low, end, DownChannelColor);    //    
   DrawLine(end, targetU, next, TargetUp1Color);   //    1
   DrawLine(end, targetD, next, TargetDn1Color);   //    1
   DrawLine(end, targetU2, next, TargetUp2Color);  //    2
   DrawLine(end, targetD2, next, TargetDn2Color);  //    2
// - 2 - ==   =============================================================

// - 3 - ==      ==========================================
   DrawLabel(start, high, UpChannelColor);         //     
   DrawLabel(start, low, DownChannelColor);        //     
   DrawLabel(end, targetU, TargetUp1Color);        //      1
   DrawLabel(end, targetD, TargetDn1Color);        //      1
   DrawLabel(end, targetU2, TargetUp2Color);       //      2
   DrawLabel(end, targetD2, TargetDn2Color);       //      2
// - 3 - ==   =============================================================
   return(true);
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
{
// - 1 - ==    ===========================================
   if (!Activate) return(0);
// - 1 - ==   =============================================================   

// - 2 - ==       ===============================
   int counted_bars = IndicatorCounted();
   if (counted_bars>0) counted_bars--;
   int limit = MathMin(BarMax, Bars - counted_bars);
   Print("limit = ", limit);
   datetime start, end, next;                      //     ..
                                                   // ..    ..
                                                   // ..
// - 2 - ==   =============================================================   

// - 3 - ==    ==============================================
   for (int i = limit; i >= 0; i--)
   {
      int res = IsTimeOutOfFlat(Time[i], start,    // ,   ..
                                end, next);        // ..
      if (res < 0)                                 //   .  ..
      {                                            // .. 
         Comment("  .  ...");
         return(0);
      }                                                   
      if (res > 0)                                 //     ,..
      {                                            // ..   ..
         if (!ShowLevels(start, end, next))        // ..  
         {
            Comment("  .  ...");
            return(0);
         }
         LastDay = next - 86400;                   // ,     ..
                                                   // ..  
      }
   }
// - 3 - ==   =============================================================   

   WindowRedraw();
   return(0);
}

